(in-package 'types)

;;;
;;; Change the function printing routine since we don't need exceptions.
;;;
(defun print-func (s p typ eqns &key substn)
  (let ((paren (paren? p func-type)))
    (when paren (open-paren s))
    (print-type s func-type (type-t1 typ) eqns :substn substn)
    (format s "~a"  *func-glyph1*)
    (print-type s func-type (type-t2 typ) eqns :substn substn)
    (when paren (close-paren s))))


(defvar alphabet `(#\a #\b #\c #\d #\e #\f #\g #\h #\i #\j #\k #\l #\m
		   #\n #\o #\p #\q #\r #\s #\t #\u #\v #\w #\x #\y #\z))

(defun alpha-subst (vlist)
  (let ((ziplist (mapcar #'cons vlist alphabet)))
    (substitution-list (mapcar #'car ziplist) (mapcar #'cdr ziplist))))

;;; Must reload the printer table  . . .
(compile&load *type-compile* *type-load* *type-pathname* '("printer_tbl"))
