;;;
;;; This is the global make file for the Illyria system.
;;;

(if (not (find-package 'types)) 
    (make-package 'types :use '(lisp user)))
(in-package 'types)

;;;
;;; Change this pathname to correspond to the directory structure
;;; on your system.
;;;
(defvar *path* "~/Illyria/")

;;;
;;; On some systems, it is necessary to change the extension on
;;; object files.  Replace "fas" with the extension used by your lisp system.
;;;
(defvar *object-file-extension* "fas")



(load (concatenate 'string *path* "utilities.lisp"))

(defvar *type-definitely-no-compile* nil)
(defvar *type-compile* nil)

;;;
;;; Uncomment the following line if you don't want to be prompted
;;; about compiling the system when loading.
;;;
;(setq *type-definitely-no-compile* t)
(setq *type-compile*
      (if (not *type-definitely-no-compile*)
	  (y-or-n-p "~% Do you want to compile the system?")))

;;; load the constraint solver
(load (concatenate 'string *path* "solver/make.lisp"))

;;; load Illyria type inference
(load (concatenate 'string *path* "inference/make.lisp"))

