(in-package 'types)

;;;
;;; This file is the continuation of alpha-subst_fns.lisp
;;; This is where the functions defined in alpha-subst_fns.lisp get called 
;;;
;;; type-alpha-substitute : type * (var -.> var | :no-change) * eqns -> type 
;;; 

;;;
;;; The main lookup table

(defconstant *alpha-substarray*
  (make-array '(13)
	      :initial-contents
	      (list #'alpha-subst-zero #'alpha-subst-one #'alpha-subst-union #'alpha-subst-inter #'alpha-subst-cons #'alpha-subst-func 
		    #'alpha-subst-var #'alpha-subst-bvar #'alpha-subst-not #'alpha-subst-dep #'alpha-subst-value 
		    #'alpha-subst-quant #'alpha-subst-lambda)))
	      
;;; The auxiliary substituting function applies the appropriate function.

;;;
;;; h is the alpha-substitution function
;;; p is a predicate that determines whether the alpha-substitution should be
;;; applied to the type
;;;
(defun type-alpha-subst-aux (typ h p eqns) 
  (if (funcall p typ h p eqns)
      (funcall (aref *alpha-substarray* (type-type typ)) typ h p eqns)
    :no-change))

;;; The top level alpha-substitution  function. Calls the type-alpha-subst-aux function
;;;
(defun type-alpha-subst (typ h p eqns)                
  (let ((result (type-alpha-subst-aux typ h p eqns)))
    (if (eql :no-change result) 
	(values typ :no-change)       
        (values result :change))))

