(in-package 'types)

;;;
;;; This file is the continuation of compl_fns.lisp
;;; This is where the functions defined in compl_fns.lisp get called 
;;;


;;;
;;; The main lookup table

(defconstant *complarray*
  (make-array '(11)
	      :initial-contents
	      (list #'compl-zero #'compl-one #'compl-union #'compl-inter #'compl-cons #'compl-func 
		    #'compl-var #'compl-bvar #'compl-not #'compl-dep #'compl-value )))
	      
;;; The auxiliary compl-ing function : applies the appropriate function.


(defun type-compl-aux (typ eqns) 
  (let ((m (type-memo typ)))
    (if m 
	(type-simplify m eqns)
      (let ((compl 
	     (funcall (aref *complarray* (type-type typ)) typ eqns)))
	(install-type-memo typ compl)
	;; for mysterious reasons the followng lines make things
	;; slower in expandvars01.
	;;(if (is-hattype typ) 
	;;  (install-type-memo compl typ))
	compl))))
  

;;; The top level complementing function. Calls the type-compl-aux function to do the actual fn call.
(defun type-compl (typ eqns)
  (type-compl-aux typ eqns))
