(in-package 'types)


;;; Functions for the constraints abstract data type.
;;; Constraints are represented as association lists
;;; Each constraint is of the form (var.X) denoting var <= X   
;;;                             or (X.var) denoting X <= var

(define-function 'constraint-lhs  #'car)
(define-function 'constraint-rhs  #'cdr)
(define-function 'make-constraint #'cons)

(defun constraints-empty () nil)

(defun constraints-add (lhs rhs c) 
  (cons (make-constraint lhs rhs) c))

(defun constraints-compose (&rest lists-of-constraints)
  (apply #'append lists-of-constraints)) 
