(in-package 'types)

;;; type-neg :: Type -> List of vars (no duplicates, no hattypes)
;;;
;;; This file is the continuation of neg-fns.lisp
;;; This is where the functions defined in neg_fns.lisp get called 
;;;
;;; eqns are needed only for the purpose of reporting statistics.
;;;


;;;
;;; The main lookup table

(defconstant *negarray*
  (make-array '(11)
	      :initial-contents
	      (list #'neg-zero #'neg-one #'neg-union #'neg-inter #'neg-cons #'neg-func 
		    #'neg-var #'neg-bvar #'neg-not #'neg-dep #'neg-value )))
	      
;;; The auxiliary neg-ing function : applies the appropriate function.

(defun type-neg-aux (typ vs Eqns) 
  (funcall (aref *negarray* (type-type typ)) typ vs Eqns))
  

;;; The top level neg-ing function. Calls the type-neg-aux function

(defun type-neg (typ eqns)                
  (type-neg-aux typ nil eqns))
