(in-package 'types)

;;; 
;;; This file is the continuation of not_zero_fns.lisp
;;; This is where the functions defined in not_zero_fns.lisp get called 
;;;
;;; This function is used in type-dep (mktype.lisp) and type-substitute 
;;; (substitution.lisp) to ensure that dependent types are simplified as 
;;; if possible.

;;; type-not-zero :: type * Eqns ->  T/F (True if the type is not-zero in all subst)
;;;
;;; The lookup table

(defconstant *not-zero-array*
  (make-array '(11)
	      :initial-contents
	      (list #'not-zero-zero #'not-zero-one #'not-zero-union #'not-zero-inter #'not-zero-cons #'not-zero-func 
		    #'not-zero-var #'not-zero-bvar #'not-zero-not #'not-zero-dep #'not-zero-value )))
	      
;;; The auxiliary not-zero function : applies the appropriate function ONCE 
;;; in the iterative fix point computation and updates stats if necessary

(defun type-not-zero-aux (typ as tbl) 
  (if (and (is-hattype typ) (not (is-zero typ))) 
      t
    (funcall (aref *not-zero-array* (type-type typ)) typ as tbl)))
  

;;;
;;; The top level not-zero function. Calls the type-not-zero-aux function

(defun type-not-zero-for-sure (typ eqns)  
  (type-not-zero-aux typ (assump-empty) eqns))
  
