(in-package 'types)

;;; type-pos :: Type -> List of VARS (no duplicates, no hattypes).
;;;
;;; This file is the continuation of pos-fns.lisp
;;; This is where the functions defined in pos_fns.lisp get called 
;;;

;;; 10/6/92 tkl  created


;;;
;;; The main lookup table

(defconstant *posarray*
  (make-array '(11)
	      :initial-contents
	      (list #'pos-zero #'pos-one #'pos-union #'pos-inter #'pos-cons #'pos-func 
		    #'pos-var #'pos-bvar #'pos-not #'pos-dep #'pos-value )))
	      
;;; The auxiliary pos-ing function : applies the appropriate function.


(defun type-pos-aux (typ vs Eqns) 
    (funcall (aref *posarray* (type-type typ)) typ vs Eqns))
  

;;; The top level pos-ing function. Calls the type-pos-aux function
;;; Also keeps track of the number of top level calls.

(defun type-pos (typ eqns)                
  (type-pos-aux typ nil eqns))
