(in-package 'types)

;;;
;;; An implementation of queues.
;;;


(defstruct (queue (:predicate is-queue))
  (stack1 nil)
  (stack2 nil))

(defun mk-empty-queue () (make-queue))

(defun enqueue (item queue) 
  (push item (queue-stack1 queue)))

(defun transfer-queue (queue)
  (when (null (queue-stack2 queue))
	(setf (queue-stack2 queue)
;;	      (reverse (queue-stack1 queue)))
;; tkl 3/8/93 : replaced reverse by nreverse: save some cons here..
	      (nreverse (queue-stack1 queue)))
	(setf (queue-stack1 queue) nil)))

(defun empty-queue (queue)
  (and (null (queue-stack2 queue))
       (null (queue-stack1 queue))))

(defun hdqueue (queue)
  (if (empty-queue queue)
      nil
    (progn
      (transfer-queue queue)
      (car (queue-stack2 queue)))))


(defun dequeue (queue)
  (if (empty-queue queue)
      nil
    (progn
      (transfer-queue queue)
      (pop (queue-stack2 queue)))))

(defun queue-to-list (queue)
  (append (queue-stack2 queue) (reverse (queue-stack1 queue))))

(defun copy-queue-deep (queue)
  (let ((newqueue (mk-empty-queue)))
    (setf (queue-stack1 newqueue) (copy-list (queue-stack1 queue)))
    (setf (queue-stack2 newqueue) (copy-list (queue-stack2 queue)))
    newqueue))

