(in-package 'types)

;;;
;;; This file is the continuation of tlv_fns.lisp
;;; This is where the functions defined in tlv_fns.lisp get called 
;;;
;;; type-tlv :: type -> list(vars) {free AND bound variables at the top level.
;;;
;;; The main lookup table

(defconstant *tlvarray*
  (make-array '(11)
	      :initial-contents
	      (list #'tlv-zero #'tlv-one #'tlv-union #'tlv-inter #'tlv-cons #'tlv-func 
		    #'tlv-var #'tlv-bvar #'tlv-not #'tlv-dep #'tlv-value )))
	      
;;; The auxiliary tlving function : applies the appropriate function.

(defun type-tlv-aux (typ eqns) 
  (funcall (aref *tlvarray* (type-type typ)) typ eqns))
  

;;; The top level tlving function. Calls the type-tlv-aux function.

(defun type-tlv (typ eqns)
  (type-tlv-aux typ eqns))
